#
# Spec file for Qpid C++ packages: qpidc qpidc-devel, qpidd, qpidd-devel
# svn revision: $Rev: 654927 $
#
%define qpidd qpidd
%define svnrev 687156
%define perftests "perftest topic_listener topic_publisher latencytest client_test fanout_perftest multiq_perftest python_tests quick_perftest quick_topictest run_federation_tests run_perftest run_test run-unit-tests shared_perftest start_broker stop_broker topic_perftest topictest txtest"

Name:           qpidc
Version:        0.2.%{svnrev}
Release:        2%{?dist}
Summary:        Libraries for Qpid C++ client applications
Group:          System Environment/Libraries
License:        ASL 2.0
URL:            http://rhm.et.redhat.com/qpidc
Source0:        %{name}-%{version}.tar.gz
Patch0:         RHEL4_SASL_Conf.patch
Patch1:         qpidd.patch
Patch2:         examples.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch: i386 i686 x86_64

BuildRequires: boost-devel
BuildRequires: doxygen
BuildRequires: e2fsprogs-devel
BuildRequires: libtool
BuildRequires: pkgconfig
BuildRequires: ruby

Requires: boost

Requires(post):/sbin/chkconfig
Requires(preun):/sbin/chkconfig
Requires(preun):/sbin/service
Requires(postun):/sbin/service

%description
Run-time libraries for AMQP client applications developed using Qpid
C++. Clients exchange messages with an AMQP message broker using
the AMQP protocol.

%package devel
Summary: Header files and documentation for developing Qpid C++ clients
Group: Development/System
Requires: %name = %version-%release
Requires: boost-devel
Requires: e2fsprogs-devel
Requires: python

%description devel
Libraries, header files and documentation for developing AMQP clients
in C++ using Qpid.  Qpid implements the AMQP messaging specification.

%package -n %{qpidd}
Summary: An AMQP message broker daemon
Group: System Environment/Daemons
Requires: %name = %version-%release
Requires: xqilla
Requires: xerces-c
Requires: cyrus-sasl
BuildRequires: cyrus-sasl-devel
BuildRequires: xqilla-devel
BuildRequires: xerces-c-devel

%description -n %{qpidd}
A message broker daemon that receives stores and routes messages using
the open AMQP messaging protocol.

%package -n %{qpidd}-devel
Summary: Libraries and header files for developing Qpid broker extensions
Group: Development/System
Requires: %name-devel = %version-%release
Requires: %{qpidd} = %version-%release
Requires: boost-devel
Requires: xqilla-devel

%description -n %{qpidd}-devel
Libraries and header files for developing extensions to the
Qpid broker daemon.

%package perftest
Summary: Simple benchmarking tools
Group: System Environment/Tools
Requires: qpidc = %version-%release

%description perftest
Tools for performing testing and benchmarking of MRG-Messaging

%pre
getent group qpidd >/dev/null || groupadd -r qpidd
getent passwd qpidd >/dev/null || \
  useradd -r -M -g qpidd -d %{_localstatedir}/lib/qpidd -s /sbin/nologin \
    -c "Owner of Qpidd Daemons" qpidd
exit 0

%prep
%setup -q
%patch0 
%patch1
%patch2 -p1

%build
CXXFLAGS="%{optflags} -DNDEBUG -O3" \
%configure --disable-static --without-cpg --without-graphviz --without-help2man
make %{?_smp_mflags}
# Remove this generated perl file, we don't need it and it upsets rpmlint.
rm docs/api/html/installdox
# Make perftest utilities
pushd src/tests
for ptest in %{perftests}; do
  make $ptest
done
popd

%install
rm -rf %{buildroot}
mkdir -p -m0755 %{buildroot}/%_bindir
make install DESTDIR=%{buildroot}
install -Dp -m0755 etc/qpidd %{buildroot}%{_initrddir}/qpidd
install -d -m0755 %{buildroot}%{_localstatedir}/lib/qpidd
install -d -m0755 %{buildroot}%{_libdir}/qpidd
install -d -m0755 %{buildroot}/var/run/qpidd
# Install perftest utilities
pushd %{_builddir}/%{name}-%{version}/src/tests/
for ptest in %{perftests}; do
  libtool --mode=install install -m755 $ptest %{buildroot}/%_bindir
done
popd
rm -f %{buildroot}%_libdir/*.a
rm -f %{buildroot}%_libdir/*.l
rm -f %{buildroot}%_libdir/*.la

# For the boost workaround
install -d -m0755 %{buildroot}%{_includedir}/qpid-boost/boost/detail
install -d -m0755 %{buildroot}%{_includedir}/qpid-boost/boost/ptr_container/detail
install -d -m0755 %{buildroot}%{_includedir}/qpid-boost/boost/parameter/aux_/python
install -d -m0755 %{buildroot}%{_includedir}/qpid-boost/boost/parameter/aux_/preprocessor
install -p -m0644 src/boost/*.hpp %{buildroot}%{_includedir}/qpid-boost/boost
install -p -m0644 src/boost/detail/*.hpp %{buildroot}%{_includedir}/qpid-boost/boost/detail
install -p -m0644 src/boost/ptr_container/*.hpp %{buildroot}%{_includedir}/qpid-boost/boost/ptr_container
install -p -m0644 src/boost/ptr_container/detail/*.hpp %{buildroot}%{_includedir}/qpid-boost/boost/ptr_container/detail
install -p -m0644 src/boost/parameter/*.hpp %{buildroot}%{_includedir}/qpid-boost/boost/parameter
install -p -m0644 src/boost/parameter/aux_/*.hpp %{buildroot}%{_includedir}/qpid-boost/boost/parameter/aux_
install -p -m0644 src/boost/parameter/aux_/python/*.hpp %{buildroot}%{_includedir}/qpid-boost/boost/parameter/aux_/python
install -p -m0644 src/boost/parameter/aux_/preprocessor/*.hpp %{buildroot}%{_includedir}/qpid-boost/boost/parameter/aux_/preprocessor

%clean
rm -rf %{buildroot}

%check
make check
# remove examples, are being packages separately in the rhm-docs package
rm -fr %{buildroot}/usr/share/qpidc/examples

%files
%defattr(-,root,root,-)
%doc LICENSE NOTICE README INSTALL RELEASE_NOTES DESIGN
%_libdir/libqpidcommon.so.0
%_libdir/libqpidcommon.so.0.1.0
%_libdir/libqpidclient.so.0
%_libdir/libqpidclient.so.0.1.0

%files devel
%defattr(-,root,root,-)
%_includedir/qpid/*.h
%_includedir/qpid/amqp_0_10
%_includedir/qpid/client
%_includedir/qpid/framing
%_includedir/qpid/sys
%_includedir/qpid/log
%_includedir/qpid/management
%_includedir/qpid-boost
%_libdir/libqpidcommon.so
%_libdir/libqpidclient.so
%_bindir/managementgen
%_datadir/managementgen
%doc docs/api/html

%files -n %{qpidd}
%defattr(-,root,root,-)
%_libdir/libqpidbroker.so.0
%_libdir/libqpidbroker.so.0.1.0
%_libdir/libqpidcluster.so.0
%_libdir/libqpidcluster.so.0.1.0
%_sbindir/%{qpidd}
%config(noreplace) %_sysconfdir/qpidd.conf
%config(noreplace) %_libdir/sasl2/qpidd.conf
%{_initrddir}/%{qpidd}
%attr(755, qpidd, qpidd) %_localstatedir/lib/qpidd
%attr(755, qpidd, qpidd) %_libdir/qpidd
%attr(755, qpidd, qpidd) %_localstatedir/run/qpidd
%attr(600, qpidd, qpidd) %config(noreplace) %_localstatedir/lib/qpidd/qpidd.sasldb
%doc %_mandir/man1/%{qpidd}.*

%files -n %{qpidd}-devel
%defattr(-,root,root,-)
%doc rpm/README.qpidd-devel
%defattr(-,root,root,-)
%_libdir/libqpidbroker.so
%_libdir/libqpidcluster.so
%_includedir/qpid/broker

%files perftest
%defattr(755,root,root,-)
%_bindir/perftest
%_bindir/topic_listener
%_bindir/topic_publisher
%_bindir/latencytest
%_bindir/client_test
%_bindir/fanout_perftest
%_bindir/multiq_perftest
%_bindir/python_tests
%_bindir/quick_perftest
%_bindir/quick_topictest
%_bindir/run-unit-tests
%_bindir/run_federation_tests
%_bindir/run_perftest
%_bindir/run_test
%_bindir/shared_perftest
%_bindir/start_broker
%_bindir/stop_broker
%_bindir/topic_perftest
%_bindir/topictest
%_bindir/txtest

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post -n %{qpidd}
# This adds the proper /etc/rc*.d links for the script
/sbin/chkconfig --add qpidd
/sbin/ldconfig

%preun -n %{qpidd}
# Check that this is actual deinstallation, not just removing for upgrade.
if [ $1 = 0 ]; then
        /sbin/service qpidd stop >/dev/null 2>&1 || :
        /sbin/chkconfig --del qpidd
fi

%postun -n %{qpidd}
if [ "$1" -ge "1" ]; then
        /sbin/service qpidd condrestart >/dev/null 2>&1 || :
fi
/sbin/ldconfig

%changelog
* Mon Aug 25 2008 Justin Ross <jross@redhat.com> - 0.2.687156-2
- Remove runtime dep on openais

* Thu Aug 21 2008 Michael Goulish <mgoulish@redhat.com> - 0.2.687156-1
- Updated to revision 687156 of the qpid.0-10 branch

* Thu Aug 14 2008 Justin Ross <jross@redhat.com> - 0.2.685273-1
- Updated to revision 685273 of the qpid.0-10 branch

* Thu Jun 12 2008 Nuno Santos <nsantos@redhat.com> - 0.2.666138-15
- Added perftest utilities (patch from David Sommerseth)
- Added initscript fix (patch from Ted Ross)

* Wed Jun 11 2008 Justin Ross <jross@redhat.com> - 0.2.666138-14
- Add pid and module dirs to the install step

* Wed Jun  4 2008 Matthew Farrellee <mfarrellee@redhat> - 0.2.656926-13
- sasl2 config is in /usr/lib/sasl2 not /etc/sasl2 on RHEL4
- change to etc/Makefile.am needs autoreconf

* Fri May 30 2008 Justin Ross <jross@redhat.com> - 0.2.656926-12
- Fix the boost installs

* Thu May 29 2008 Justin Ross <jross@redhat.com> - 0.2.656926-11
- Change the boost library install location to avoid file conflicts

* Thu May 29 2008 Justin Ross <jross@redhat.com> - 0.2.656926-10
- Introduce some install scripting to add special boost libraries

* Thu May 29 2008 Justin Ross <jross@redhat.com> - 0.2.656926-9
- Add a patch to handle a rhel 4 options parsing bug

* Fri May 23 2008 Justin Ross <jross@redhat.com> - 0.2.656926-7
- Restore the help2man buildrequires

* Thu May 22 2008 Nuno Santos <nsantos@redhat.com> - 0.2.656926-6
- BZ 432872: remove examples, which are being packaged separately

* Tue May 22 2008 Justin Ross <jross@redhat.com> - 0.2.656926-5
- Add the boost include dir

* Tue May 20 2008 Justin Ross <jross@redhat.com> - 0.2.656926-4
- Drop build requirements for graphviz and help2man

* Tue May 20 2008 Justin Ross <jross@redhat.com> - 0.2.656926-3
- Don't strip binaries, as we want working debuginfo packages

* Wed May 14 2008 Nuno Santos <nsantos@redhat.com> - 0.2-34
- Bumped for Beta 4

* Fri May  9 2008 Matthew Farrellee <mfarrellee@redhat> - 0.2-33
- Moved qpidd.conf from qpidc package to qpidd package
- Added BuildRequires xqilla-devel and xerces-c-devel to qpidd for XML Exchange
- Added BuildRequires openais-devel to qpidd for CPG
- Added missing Requires xqilla-devel to qpidd-devel

* Thu May  8 2008 Matthew Farrellee <mfarrellee@redhat> - 0.2-32
- Added sasl2 config file for qpidd
- Added cyrus-sasl dependencies

* Wed May  7 2008 Matthew Farrellee <mfarrellee@redhat> - 0.2-31
- Added python dependency, needed by managementgen

* Wed May  7 2008 Matthew Farrellee <mfarrellee@redhat> - 0.2-30
- Added management-types.xml to qpidc-devel package

* Tue May  6 2008 Matthew Farrellee <mfarrellee@redhat> - 0.2-29
- Added managementgen to the qpidc-devel package

* Mon Apr 14 2008 Nuno Santos <nsantos@redhat.com> - 0.2-28
 - Fix home dir permissions
 - Bumped for Fedora 9

* Mon Mar 31 2008 Nuno Santos <nsantos@redhat.com> - 0.2-25
- Create user qpidd, start qpidd service as qpidd

* Mon Feb 18 2008 Rafael Schloming <rafaels@redhat.com> - 0.2-24
- Bug fix for TCK issue in Beta 3

* Thu Feb 14 2008 Rafael Schloming <rafaels@redhat.com> - 0.2-23
- Bumped to pull in fixes for Beta 3

* Tue Feb 12 2008 Alan Conway <aconway@redhat.com> - 0.2-22
- Added -g to compile flags for debug symbols.

* Tue Feb 12 2008 Alan Conway <aconway@redhat.com> - 0.2-21
- Create /var/lib/qpidd correctly.

* Mon Feb 11 2008 Rafael Schloming <rafaels@redhat.com> - 0.2-20
- bumped for Beta 3

* Mon Jan 21 2008 Gordon Sim <gsim@redhat.com> - 0.2-18
- bump up rev for recent changes to plugin modules & mgmt

* Thu Jan 03 2008 Nuno Santos <nsantos@redhat.com> - 0.2-17
- add missing header file SessionManager.h

* Thu Jan 03 2008 Nuno Santos <nsantos@redhat.com> - 0.2-16
- limit builds to i386 and x86_64 archs

* Thu Jan 03 2008 Nuno Santos <nsantos@redhat.com> - 0.2-15
- add ruby as a build dependency

* Tue Dec 18 2007 Nuno Santos <nsantos@redhat.com> - 0.2-14
- include fixes from Gordon Sim (fragmentation, lazy-loading, staging) 
  and Alan Conway (exception handling in the client).

* Thu Dec 6 2007 Alan Conway <aconway@redhat.com> - 0.2-13
- installcheck target to build examples in installation.

* Thu Nov 8 2007 Alan Conway <aconway@redhat.com> - 0.2-10
- added examples to RPM package.

* Thu Oct 9 2007 Alan Conway <aconway@redhat.com> - 0.2-9
- added config(noreplace) for qpidd.conf

* Thu Oct 4 2007 Alan Conway <aconway@redhat.com> - 0.2-8
- Added qpidd.conf configuration file.
- Updated man page to detail configuration options.

* Thu Sep 20 2007 Alan Conway <aconway@redhat.com> - 0.2-7
- Removed apr dependency.

* Wed Aug 1 2007 Alan Conway <aconway@redhat.com> - 0.2-6
- added --disable-cluster flag

* Tue Apr 17 2007 Alan Conway <aconway@redhat.com> - 0.2-5
- Add missing Requires: e2fsprogs-devel for qpidc-devel.

* Tue Apr 17 2007 Alan Conway <aconway@redhat.com> - 0.2-4
- longer broker_start timeout to avoid failures in plague builds.

* Tue Apr 17 2007 Alan Conway <aconway@redhat.com> - 0.2-3
- Add missing Requires: apr in qpidc.

* Mon Apr 16 2007 Alan Conway <aconway@redhat.com> - 0.2-2
- Bugfix for memory errors on x86_64.

* Thu Apr 12 2007 Alan Conway <aconway@redhat.com> - 0.2-1
- Bumped version number for rhm dependencies.

* Wed Apr 11 2007 Alan Conway <aconway@redhat.com> - 0.1-5
- Add qpidd-devel sub-package.

* Mon Feb 19 2007 Jim Meyering <meyering@redhat.com> - 0.1-4
- Address http://bugzilla.redhat.com/220630:
- Remove redundant "cppunit" build-requires.
- Add --disable-static.

* Thu Jan 25 2007 Alan Conway <aconway@redhat.com> - 0.1-3
- Applied Jim Meyerings fixes from http://mail-archives.apache.org/mod_mbox/incubator-qpid-dev/200701.mbox/<87hcugzmyp.fsf@rho.meyering.net>

* Mon Dec 22 2006 Alan Conway <aconway@redhat.com> - 0.1-1
- Fixed all rpmlint complaints (with help from David Lutterkort)
- Added qpidd --daemon behaviour, fix init.rc scripts

* Fri Dec  8 2006 David Lutterkort <dlutter@redhat.com> - 0.1-1
- Initial version based on Jim Meyering's sketch and discussions with Alan
  Conway
